<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="invoicingId"
          :columns="columns"
          :datasource="datasource"
          v-model:selection="selection"
          tool-class="ele-toolbar-form"
          :scroll="{ x: 800 }"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'status'">
              <span>{{ INVOICING_STATUS_LIST[record.status] }}</span>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <Edit v-model:visible="showEdit" :data="current" @done="reload" />
      <!-- 合同详情弹窗 -->
      <Info v-model:visible="showInfo" :data="current" @done="reload" />
      <!-- 批量转移弹窗 -->
      <!--    <CustomerMove v-model:visible="showMove" :data="selection" @done="batchMove" />-->
    </div>
  </div>
</template>

<script lang="ts" setup>
import { computed, createVNode, ref } from "vue";
import { message, Modal } from "ant-design-vue";
import {
  ExclamationCircleOutlined,
  UserOutlined
} from "@ant-design/icons-vue";
import type { EleProTable } from "ele-admin-pro";
import type {
  DatasourceFunction,
  ColumnItem
} from "ele-admin-pro/es/ele-pro-table/types";
import { toDateString } from "ele-admin-pro";
import Search from "./components/search.vue";
import Edit from "./components/edit.vue";
import Info from "./components/info.vue";
import { timeAgo } from "ele-admin-pro";
import { useUserStore } from "@/store/modules/user";
import { Invoicing, INVOICING_STATUS_LIST, InvoicingParam } from "@/api/tower/invoicing/model";
import { pageInvoicing, removeBatchInvoicing, removeInvoicing } from "@/api/tower/invoicing";

const userStore = useUserStore();
// 当前用户信息
const loginUser = computed(() => userStore.info ?? {});

// 表格实例
const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

// 表格选中数据
const selection = ref<Invoicing[]>([]);
// 当前编辑数据
const current = ref<Invoicing | null>(null);

// 是否显示资产详情
const showInfo = ref(false);
// 是否显示编辑弹窗
const showEdit = ref(false);
// 是否显示批量移动弹窗
const showMove = ref(false);

// 表格数据源
const datasource: DatasourceFunction = ({
                                          page,
                                          limit,
                                          where,
                                          orders,
                                          filters
                                        }) => {
  if (filters) {
    where.status = filters.status;
  }
  return pageInvoicing({
    ...where,
    ...orders,
    page,
    limit
  });
};

// 表格列配置
const columns = ref<ColumnItem[]>([
  {
    key: "index",
    width: 48,
    align: "center",
    fixed: "left",
    hideInSetting: true,
    customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
  },
  {
    title: "开票状态",
    dataIndex: "status",
    key: "status",
  },
  {
    title: "开票日期",
    dataIndex: "invoicingDate"
  },
  {
    title: "合同编号",
    dataIndex: "contactNumber"
  },
  {
    title: "项目名称",
    dataIndex: "projectName"
  },
  {
    title: "承租单位",
    dataIndex: "customerName"
  },
  {
    title: "申请人",
    dataIndex: "requestName"
  },
  {
    title: "开票单位",
    dataIndex: "invoicingCompany"
  },
  {
    title: "开票金额",
    dataIndex: "invoicingAmount"
  },
  {
    title: "发票号",
    dataIndex: "invoicingNo"
  },
  {
    title: "申请人",
    dataIndex: "requestName"
  },
  {
    title: "备注",
    dataIndex: "remark"
  },
  {
    title: "操作",
    key: "action",
    width: 200,
    align: "center",
    hideInSetting: true
  }
]);

/* 搜索 */
const reload = (where?: InvoicingParam) => {
  selection.value = [];
  tableRef?.value?.reload({ where: where });
};

/* 打开编辑弹窗 */
const openEdit = (row?: Invoicing) => {
  current.value = row ?? null;
  showEdit.value = true;
};

const showSettle = ref<Boolean>(false);
const openSettle = (row?: Invoicing) => {
  current.value = row ?? null;
  showSettle.value = true;
};

/* 打开批量移动弹窗 */
const openMove = () => {
  showMove.value = true;
};

/* 打开用户详情弹窗 */
const openInfo = (row?: Invoicing) => {
  current.value = row ?? null;
  showInfo.value = true;
};

/* 删除单个 */
const remove = (row: Invoicing) => {
  const hide = message.loading("请求中..", 0);
  removeInvoicing(row.invoicingId)
    .then((msg) => {
      hide();
      message.success(msg);
      reload();
    })
    .catch((e) => {
      hide();
      message.error(e.message);
    });
};

/* 批量转移 */
const batchMove = (userId) => {
  console.log(userId, "批量转移0000");
  console.log(selection.value);
};

/* 批量删除 */
const removeBatch = () => {
  if (!selection.value.length) {
    message.error("请至少选择一条数据");
    return;
  }
  Modal.confirm({
    title: "提示",
    content: "确定要删除选中的记录吗?",
    icon: createVNode(ExclamationCircleOutlined),
    maskClosable: true,
    onOk: () => {
      const hide = message.loading("请求中..", 0);
      removeBatchInvoicing(
        selection.value.map((d) => {
          if (loginUser.value.userId === d.userId) {
            return d.invoicingId;
          }
        })
      )
        .then((msg) => {
          hide();
          message.success(msg);
          reload();
        })
        .catch((e) => {
          hide();
          message.error(e.message);
        });
    }
  });
};
</script>

<script lang="ts">
export default {
  name: "Accessory"
};
</script>

<style lang="less" scoped>
.sys-org-table :deep(.ant-table-body) {
  overflow: auto !important;
  overflow: overlay !important;
}

.sys-org-table :deep(.ant-table-pagination.ant-pagination) {
  padding: 0 4px;
  margin-bottom: 0;
}
</style>
